clear
a1= 1.5;
a2= 0.6;
l1 = 0.03;
l2 = 0.001;

t = logspace(0,3);
y = a1.*exp(-l1.*t)+a2.*exp(-l2.*t);

Y = awgn(y,20);
figure, plot(t,Y,'o',t,y,'r-')

legend('real','ideal')

s = fitoptions('Method', 'NonlinearLeastSquares',...
    'Startpoint', [1 0.5 1e-2 3e-3]);
f = fittype('A1*exp(-L1*x)+A2*exp(-L2*x)','options',s);

[C_fit,D_fit]=fit(t',Y',f)


Y_fitted = C_fit.A1.*exp(-C_fit.L1.*t)+ C_fit.A2.*exp(-C_fit.L2.*t);

hold on
plot(t,Y_fitted,'g-*');

legend('real','ideal','fitting');



L1 = sym('L1', 'positive');
L2 = sym('L2', 'positive');
A1 = sym('A1', 'positive');
A2 = sym('A2', 'positive');



k21 = sym('k21', 'positive');
k01 = sym('k01', 'positive');
k12 = sym('k12', 'positive');

V1 = sym('V1','positive');

s = sym('s', 'positive');

A = [-(k01+k21) k12
k21 -k12]

B = [1
0]

C = [1/V1 0]

 
H = C*inv(eye(2)*s-A)*B


trasferim = collect(A1/(s+L1) + A2/(s+L2))

% pretty(trasferim)
% 
% expand(trasferim)
% 
% simple(trasferim)
% 
% collect(trasferim)

L1 = 0.03;      %ad L1, L2, A1, A2 viene attribuito il valore "ideale"
L2 = 0.001;
A1 = 1.5;
A2 = 0.6;

subs(trasferim)


V1 = 1/(A1+A2)
k12 = (A1*L2+A2*L1)*V1
k01 = (L1*L2)/k12
k21 = (L1+L2)-k12-k01



L1_r = C_fit.L1;   %ad L1_r, L2_r, ... viene attribuito il valore "stimato"
L2_r = C_fit.L2;
A1_r = C_fit.A1;
A2_r = C_fit.A2;


V1_r = 1/(A1_r+A2_r)
k12_r = (A1_r*L2_r+A2_r*L1_r)*V1_r
k01_r = (L1_r*L2_r)/k12_r
k21_r = (L1_r+L2_r)-k12_r-k01_r


errore_V1 = 100*(V1_r-V1)/V1
errore_k12_r = 100*(k12_r-k12)/k12
errore_k21_r = 100*(k21_r-k21)/k21
errore_k01_r = 100*(k01_r-k01)/k01









